From f365ca8f0a4569d40da9909074dcace0de7a58db Mon Sep 17 00:00:00 2001
From: Guennadi Liakhovetski <g.liakhovetski@gmx.de>
Date: Thu, 4 Jun 2009 13:17:14 +0200
Subject: [PATCH 23/42] tw9910: return updated geometry on successful S_FMT and S_CROP

Signed-off-by: Guennadi Liakhovetski <g.liakhovetski@gmx.de>
---
 drivers/media/video/tw9910.c |   14 ++++++++++++--
 1 files changed, 12 insertions(+), 2 deletions(-)

diff --git a/drivers/media/video/tw9910.c b/drivers/media/video/tw9910.c
index 7199e0f..83596cb 100644
--- a/drivers/media/video/tw9910.c
+++ b/drivers/media/video/tw9910.c
@@ -699,6 +699,11 @@ static int tw9910_set_crop(struct soc_camera_device *icd,
 	if (ret < 0)
 		goto tw9910_set_fmt_error;
 
+	rect->width = priv->scale->width;
+	rect->height = priv->scale->height;
+	rect->left = 0;
+	rect->top = 0;
+
 	return ret;
 
 tw9910_set_fmt_error:
@@ -720,7 +725,7 @@ static int tw9910_s_fmt(struct v4l2_subdev *sd, struct v4l2_format *f)
 		.width	= pix->width,
 		.height	= pix->height,
 	};
-	int i;
+	int i, ret;
 
 	/*
 	 * check color format
@@ -732,7 +737,12 @@ static int tw9910_s_fmt(struct v4l2_subdev *sd, struct v4l2_format *f)
 	if (i == ARRAY_SIZE(tw9910_color_fmt))
 		return -EINVAL;
 
-	return tw9910_set_crop(icd, &rect);
+	ret = tw9910_set_crop(icd, &rect);
+	if (!ret) {
+		pix->width = rect.width;
+		pix->height = rect.height;
+	}
+	return ret;
 }
 
 static int tw9910_try_fmt(struct v4l2_subdev *sd, struct v4l2_format *f)
-- 
1.6.2.4

